Send risk evaluation feedback (time range)
POST {{apiPath}}/v1/environments/{{envID}}/riskFeedback
This sample uses the riskFeedback endpoint to send feedback regarding the results of a single risk evaluation that was carried out.
The body of the request includes the occurredFrom and occurredTo fields, which are required when subject.type is set to TIME_RANGE. Use TIME_RANGE when you don’t have the PingOne ID for the relevant risk evaluation and you want to provide a time range during which the risk evaluation was carried out. The range can be up to 3 days.
The Content-Type header request is set to application/vnd.pingidentity.risk.feedback.v2+json. This instructs PingOne to use risk evaluation feedback v2.
Prerequisites
-
Refer to Risk Evaluations for important overview information.
Request Model
For complete property descriptions, refer to Risk evaluation feedback data model - v2
| Property | Type | Required |
|---|---|---|
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
Date |
Required |
|
Date |
Required |
|
String |
Optional |
|
Object |
Required |
|
String |
Required |
|
String |
Optional |
|
String |
Required |
Headers
Authorization Bearer {{accessToken}}
Content-Type application/vnd.pingidentity.risk.feedback.v2+json
Body
raw ( application/vnd.pingidentity.risk.feedback.v2+json )
{
"subject": {
"type": "TIME_RANGE"
},
"occurredFrom": "2026-05-03T08:00:00.000Z",
"occurredTo": "2026-05-05T08:00:00.000Z",
"verdict": "FRAUD",
"trigger": "THIRD_PARTY_SIGNAL",
"flowType": "TRANSACTION",
"fraudType" : "account takeover",
"confirmedAt": "2026-05-15T10:30:00.000Z",
"reason": "Third-party fraud notifications identified unauthorized transaction activity during this period.",
"analyst": "analyst_1234@example.com",
"confidence": "HIGH"
}
Example Request
-
cURL
-
C#
-
Go
-
HTTP
-
Java
-
jQuery
-
NodeJS
-
Python
-
PHP
-
Ruby
-
Swift
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/riskFeedback' \
--header 'Content-Type: application/vnd.pingidentity.risk.feedback.v2+json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data-raw '{
"subject": {
"type": "TIME_RANGE"
},
"occurredFrom": "2026-05-03T08:00:00.000Z",
"occurredTo": "2026-05-05T08:00:00.000Z",
"verdict": "FRAUD",
"trigger": "THIRD_PARTY_SIGNAL",
"flowType": "TRANSACTION",
"fraudType" : "account takeover",
"confirmedAt": "2026-05-15T10:30:00.000Z",
"reason": "Third-party fraud notifications identified unauthorized transaction activity during this period.",
"analyst": "analyst_1234@example.com",
"confidence": "HIGH"
}'
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/riskFeedback")
{
MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/vnd.pingidentity.risk.feedback.v2+json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@" ""subject"": { " + "\n" +
@" ""type"": ""TIME_RANGE""" + "\n" +
@" }," + "\n" +
@" ""occurredFrom"": ""2026-05-03T08:00:00.000Z""," + "\n" +
@" ""occurredTo"": ""2026-05-05T08:00:00.000Z""," + "\n" +
@" ""verdict"": ""FRAUD""," + "\n" +
@" ""trigger"": ""THIRD_PARTY_SIGNAL""," + "\n" +
@" ""flowType"": ""TRANSACTION""," + "\n" +
@" ""fraudType"" : ""account takeover""," + "\n" +
@" ""confirmedAt"": ""2026-05-15T10:30:00.000Z""," + "\n" +
@" ""reason"": ""Third-party fraud notifications identified unauthorized transaction activity during this period.""," + "\n" +
@" ""analyst"": ""analyst_1234@example.com""," + "\n" +
@" ""confidence"": ""HIGH""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "{{apiPath}}/v1/environments/{{envID}}/riskFeedback"
method := "POST"
payload := strings.NewReader(`{
"subject": {
"type": "TIME_RANGE"
},
"occurredFrom": "2026-05-03T08:00:00.000Z",
"occurredTo": "2026-05-05T08:00:00.000Z",
"verdict": "FRAUD",
"trigger": "THIRD_PARTY_SIGNAL",
"flowType": "TRANSACTION",
"fraudType" : "account takeover",
"confirmedAt": "2026-05-15T10:30:00.000Z",
"reason": "Third-party fraud notifications identified unauthorized transaction activity during this period.",
"analyst": "analyst_1234@example.com",
"confidence": "HIGH"
}`)
client := &http.Client {
}
req, err := http.NewRequest(method, url, payload)
if err != nil {
fmt.Println(err)
return
}
req.Header.Add("Content-Type", "application/vnd.pingidentity.risk.feedback.v2+json")
req.Header.Add("Authorization", "Bearer {{accessToken}}")
res, err := client.Do(req)
if err != nil {
fmt.Println(err)
return
}
defer res.Body.Close()
body, err := io.ReadAll(res.Body)
if err != nil {
fmt.Println(err)
return
}
fmt.Println(string(body))
}
POST /v1/environments/{{envID}}/riskFeedback HTTP/1.1
Host: {{apiPath}}
Content-Type: application/vnd.pingidentity.risk.feedback.v2+json
Authorization: Bearer {{accessToken}}
{
"subject": {
"type": "TIME_RANGE"
},
"occurredFrom": "2026-05-03T08:00:00.000Z",
"occurredTo": "2026-05-05T08:00:00.000Z",
"verdict": "FRAUD",
"trigger": "THIRD_PARTY_SIGNAL",
"flowType": "TRANSACTION",
"fraudType" : "account takeover",
"confirmedAt": "2026-05-15T10:30:00.000Z",
"reason": "Third-party fraud notifications identified unauthorized transaction activity during this period.",
"analyst": "analyst_1234@example.com",
"confidence": "HIGH"
}
OkHttpClient client = new OkHttpClient().newBuilder()
.build();
MediaType mediaType = MediaType.parse("application/vnd.pingidentity.risk.feedback.v2+json");
RequestBody body = RequestBody.create(mediaType, "{\n \"subject\": { \n \"type\": \"TIME_RANGE\"\n },\n \"occurredFrom\": \"2026-05-03T08:00:00.000Z\",\n \"occurredTo\": \"2026-05-05T08:00:00.000Z\",\n \"verdict\": \"FRAUD\",\n \"trigger\": \"THIRD_PARTY_SIGNAL\",\n \"flowType\": \"TRANSACTION\",\n \"fraudType\" : \"account takeover\",\n \"confirmedAt\": \"2026-05-15T10:30:00.000Z\",\n \"reason\": \"Third-party fraud notifications identified unauthorized transaction activity during this period.\",\n \"analyst\": \"analyst_1234@example.com\",\n \"confidence\": \"HIGH\"\n}");
Request request = new Request.Builder()
.url("{{apiPath}}/v1/environments/{{envID}}/riskFeedback")
.method("POST", body)
.addHeader("Content-Type", "application/vnd.pingidentity.risk.feedback.v2+json")
.addHeader("Authorization", "Bearer {{accessToken}}")
.build();
Response response = client.newCall(request).execute();
var settings = {
"url": "{{apiPath}}/v1/environments/{{envID}}/riskFeedback",
"method": "POST",
"timeout": 0,
"headers": {
"Content-Type": "application/vnd.pingidentity.risk.feedback.v2+json",
"Authorization": "Bearer {{accessToken}}"
},
"data": JSON.stringify({
"subject": {
"type": "TIME_RANGE"
},
"occurredFrom": "2026-05-03T08:00:00.000Z",
"occurredTo": "2026-05-05T08:00:00.000Z",
"verdict": "FRAUD",
"trigger": "THIRD_PARTY_SIGNAL",
"flowType": "TRANSACTION",
"fraudType": "account takeover",
"confirmedAt": "2026-05-15T10:30:00.000Z",
"reason": "Third-party fraud notifications identified unauthorized transaction activity during this period.",
"analyst": "analyst_1234@example.com",
"confidence": "HIGH"
}),
};
$.ajax(settings).done(function (response) {
console.log(response);
});
var request = require('request');
var options = {
'method': 'POST',
'url': '{{apiPath}}/v1/environments/{{envID}}/riskFeedback',
'headers': {
'Content-Type': 'application/vnd.pingidentity.risk.feedback.v2+json',
'Authorization': 'Bearer {{accessToken}}'
},
body: JSON.stringify({
"subject": {
"type": "TIME_RANGE"
},
"occurredFrom": "2026-05-03T08:00:00.000Z",
"occurredTo": "2026-05-05T08:00:00.000Z",
"verdict": "FRAUD",
"trigger": "THIRD_PARTY_SIGNAL",
"flowType": "TRANSACTION",
"fraudType": "account takeover",
"confirmedAt": "2026-05-15T10:30:00.000Z",
"reason": "Third-party fraud notifications identified unauthorized transaction activity during this period.",
"analyst": "analyst_1234@example.com",
"confidence": "HIGH"
})
};
request(options, function (error, response) {
if (error) throw new Error(error);
console.log(response.body);
});
import requests
import json
url = "{{apiPath}}/v1/environments/{{envID}}/riskFeedback"
payload = json.dumps({
"subject": {
"type": "TIME_RANGE"
},
"occurredFrom": "2026-05-03T08:00:00.000Z",
"occurredTo": "2026-05-05T08:00:00.000Z",
"verdict": "FRAUD",
"trigger": "THIRD_PARTY_SIGNAL",
"flowType": "TRANSACTION",
"fraudType": "account takeover",
"confirmedAt": "2026-05-15T10:30:00.000Z",
"reason": "Third-party fraud notifications identified unauthorized transaction activity during this period.",
"analyst": "analyst_1234@example.com",
"confidence": "HIGH"
})
headers = {
'Content-Type': 'application/vnd.pingidentity.risk.feedback.v2+json',
'Authorization': 'Bearer {{accessToken}}'
}
response = requests.request("POST", url, headers=headers, data=payload)
print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/riskFeedback');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
'follow_redirects' => TRUE
));
$request->setHeader(array(
'Content-Type' => 'application/vnd.pingidentity.risk.feedback.v2+json',
'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n "subject": { \n "type": "TIME_RANGE"\n },\n "occurredFrom": "2026-05-03T08:00:00.000Z",\n "occurredTo": "2026-05-05T08:00:00.000Z",\n "verdict": "FRAUD",\n "trigger": "THIRD_PARTY_SIGNAL",\n "flowType": "TRANSACTION",\n "fraudType" : "account takeover",\n "confirmedAt": "2026-05-15T10:30:00.000Z",\n "reason": "Third-party fraud notifications identified unauthorized transaction activity during this period.",\n "analyst": "analyst_1234@example.com",\n "confidence": "HIGH"\n}');
try {
$response = $request->send();
if ($response->getStatus() == 200) {
echo $response->getBody();
}
else {
echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
$response->getReasonPhrase();
}
}
catch(HTTP_Request2_Exception $e) {
echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"
url = URI("{{apiPath}}/v1/environments/{{envID}}/riskFeedback")
http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/vnd.pingidentity.risk.feedback.v2+json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
"subject": {
"type": "TIME_RANGE"
},
"occurredFrom": "2026-05-03T08:00:00.000Z",
"occurredTo": "2026-05-05T08:00:00.000Z",
"verdict": "FRAUD",
"trigger": "THIRD_PARTY_SIGNAL",
"flowType": "TRANSACTION",
"fraudType": "account takeover",
"confirmedAt": "2026-05-15T10:30:00.000Z",
"reason": "Third-party fraud notifications identified unauthorized transaction activity during this period.",
"analyst": "analyst_1234@example.com",
"confidence": "HIGH"
})
response = http.request(request)
puts response.read_body
let parameters = "{\n \"subject\": { \n \"type\": \"TIME_RANGE\"\n },\n \"occurredFrom\": \"2026-05-03T08:00:00.000Z\",\n \"occurredTo\": \"2026-05-05T08:00:00.000Z\",\n \"verdict\": \"FRAUD\",\n \"trigger\": \"THIRD_PARTY_SIGNAL\",\n \"flowType\": \"TRANSACTION\",\n \"fraudType\" : \"account takeover\",\n \"confirmedAt\": \"2026-05-15T10:30:00.000Z\",\n \"reason\": \"Third-party fraud notifications identified unauthorized transaction activity during this period.\",\n \"analyst\": \"analyst_1234@example.com\",\n \"confidence\": \"HIGH\"\n}"
let postData = parameters.data(using: .utf8)
var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/riskFeedback")!,timeoutInterval: Double.infinity)
request.addValue("application/vnd.pingidentity.risk.feedback.v2+json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")
request.httpMethod = "POST"
request.httpBody = postData
let task = URLSession.shared.dataTask(with: request) { data, response, error in
guard let data = data else {
print(String(describing: error))
return
}
print(String(data: data, encoding: .utf8)!)
}
task.resume()
Example Response
201 Created
{
"_links": {
"environment": {
"href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
}
},
"id": "47455fdd-dc2c-431d-b4bb-35b558a086ea",
"environment": {
"id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
},
"subject": {
"type": "TIME_RANGE"
},
"verdict": "FRAUD",
"occurredFrom": "2026-05-03T08:00:00.000Z",
"occurredTo": "2026-05-05T08:00:00.000Z",
"trigger": "THIRD_PARTY_SIGNAL",
"flowType": "TRANSACTION",
"confirmedAt": "2026-05-15T10:30:00.000Z",
"reason": "Third-party fraud notifications identified unauthorized transaction activity during this period.",
"analyst": "analyst_1234@example.com",
"confidence": "HIGH",
"fraudType": "account takeover",
"createdAt": "2026-11-15T13:55:25.358Z",
"updatedAt": "2026-11-15T13:55:25.358Z"
}